#ifndef NSQL_H
#define NSQL_H

#ifndef _mysql_h
	#include <mysql/mysql.h>
#endif

class NSQL_ARGS{
public:
	char *server;
	char *db;
	/*~PROTOBEG~ NSQL_ARGS */
public:
	NSQL_ARGS (const char *_server, const char *_db);
	NSQL_ARGS (void);
	int isok (void);
	void setdb (const char *s);
	void setserver (const char *s);
	~NSQL_ARGS (void);
	/*~PROTOEND~ NSQL_ARGS */
};


class NSQL{
	MYSQL my;
	int connected;
	char *server;
	char *db;
	/*~PROTOBEG~ NSQL */
public:
	NSQL (NSQL_ARGS&args);
	NSQL (const char *server, const char *db);
	int a_query (const char *req);
	int a_queryf (const char *ctl, ...);
	int connect (void);
	int disconnect (void);
	const char *error (void);
	void free_result (MYSQL_RES *res);
	int numrows (MYSQL_RES *res);
	int query (const char *req);
	int queryf (const char *ctl, ...);
	MYSQL_RES *store_result (void);
	~NSQL (void);
	/*~PROTOEND~ NSQL */
};

//#include "nsql.p"

#endif

