#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <wait.h>
#include <unistd.h>
#include <pthread.h>


int test_fork (int argc, char *argv[])
{
	// pthread_t t1;
	const int maxthread = 400;
	int tb[maxthread][2];
	for (int i=0; i<maxthread; i++){
		pipe(tb[i]);
	}
	int nbtr = atoi(argv[1]);
	printf ("Nombre de thread = %d\n",nbtr);
	for (int i=0; i<nbtr; i++){
		int pid = fork();
		if (pid==0){
			int fin = tb[i][0];
			int fout = i==nbtr-1 ? -1 : tb[i+1][1];
			for (int i=0; i<maxthread; i++){
				if (tb[i][1] != fout) close (tb[i][1]);
			}
			int n;
			char buf[10000];
			int nbpaquet = 0;
			while ((n=read(fin,buf,sizeof(buf)))>0){
				nbpaquet++;
				// printf ("pid %d %d\n",getpid(),n);
				if (fout != -1) write (fout,buf,n);
			}
			if (argv[2] != NULL) printf ("pid %d nbpaquet %d\n",getpid(),nbpaquet);
			_exit(0);
		}else if (pid == -1){
			printf ("Can't fork %s\n",strerror(errno));
		}
	}
	int n;
	char buf[10000];
	while ((n=read(0,buf,sizeof(buf)))>0){
		write (tb[0][1],buf,n);
	}
	printf ("eof\n");
	for (int i=0; i<maxthread; i++) close(tb[i][1]);
	int status;
	while (wait(&status)!=-1);
	return 0;
}	

struct THINFO{
	int fin;
	int fout;
};

static void *test_task (void *p)
{
	THINFO *info = (THINFO*)p;
	int fin = info->fin;
	int fout = info->fout;
	int n;
	char buf[10000];
	int nbpaquet = 0;
	while ((n=read(fin,buf,sizeof(buf)))>0){
		nbpaquet++;
		// printf ("pid %d %d\n",getpid(),n);
		if (fout != -1) write (fout,buf,n);
	}
	// printf ("pid %d nbpaquet %d\n",getpid(),nbpaquet);
	close (fout);
	return NULL;
}

int test_thread (int argc, char *argv[])
{
	const int maxthread = 400;
	pthread_t t[maxthread];
	int tb[maxthread][2];
	for (int i=0; i<maxthread; i++){
		pipe(tb[i]);
	}
	int nbtr = atoi(argv[1]);
	printf ("Nombre de thread = %d\n",nbtr);
	THINFO infos[maxthread];
	for (int i=0; i<nbtr; i++){
		infos[i].fin = tb[i][0];
		infos[i].fout = i==nbtr-1 ? -1 : tb[i+1][1];
		if (pthread_create (&t[i],NULL,test_task,&infos[i]) !=0){
			printf ("Can't create thread %s\n",strerror(errno));
		}
	}
	int n;
	char buf[10000];
	while ((n=read(0,buf,sizeof(buf)))>0){
		write (tb[0][1],buf,n);
	}
	printf ("eof\n");
	close(tb[0][1]);
	void *status;
	for (int i=0; i<nbtr; i++) pthread_join (t[i],&status);
	return 0;
}	

void *thread_null(void *)
{
	return NULL;
}

void test_create (int argc, char *argv[])
{
	int nbtr = atoi(argv[1]);
	for (int i=0; i<nbtr; i++){
		pthread_t t[100];
		for (int j=0; j<100; j++){
			if (pthread_create (&t[j],NULL,thread_null,NULL)!=0){
				printf ("Can't create thread %s\n",strerror(errno));
				break;
			}
		}
		for (int j=0; j<100; j++){
			void *status;
			pthread_join (t[j],&status);
		}
	}
}

void test_createfork (int argc, char *argv[])
{
	int nbtr = atoi(argv[1]);
	for (int i=0; i<nbtr; i++){
		if (fork()==0){
			_exit(0);
		}else{
			int status;
			wait (&status);
		}
	}
}

void test_readpack(int argc, char *argv[])
{
	int tbin[2],tbout[2];
	pipe(tbin);
	pipe(tbout);
	int nbtr = atoi(argv[1]);
	for (int i=0; i<nbtr; i++){
		if (fork()==0){
			close (tbin[1]);
			int nbpaquet = 0;
			char buf[100];
			while (read(tbin[0],buf,100)>0){
				nbpaquet++;
				write (tbout[1],buf,100);
			}
			printf ("pid %d %d\n",getpid(),nbpaquet);
			_exit(0);
		}
	}
	for (int i=0; i<10000; i++){
		char buf[100];
		write (tbin[1],buf,100);
		read (tbout[0],buf,100);
	}
	close (tbin[1]);
	int status;
	while (wait(&status)!= -1);
}

void *thread_read (void *p)
{
	THINFO *info = (THINFO*)p;
	int fin = info->fin;
	int fout = info->fout;
	int nbpaquet = 0;
	char buf[100];
	while (read(fin,buf,100)>0){
		nbpaquet++;
		write (fout,buf,100);
		usleep (1000);
	}
	printf ("pid %d %d\n",getpid(),nbpaquet);
	return NULL;
}


void test_preadpack(int argc, char *argv[])
{
	int tbin[2],tbout[2];
	pipe(tbin);
	pipe(tbout);
	int nbtr = atoi(argv[1]);
	pthread_t t[nbtr];
	THINFO infos[nbtr];
	for (int i=0; i<nbtr; i++){
		infos[i].fin = tbin[0];
		infos[i].fout = tbout[1];
		pthread_create (&t[i],NULL,thread_read,&infos[i]);
	}
	for (int i=0; i<100; i++){
		char buf[100];
		write (tbin[1],buf,100);
		read (tbout[0],buf,100);
	}
	close (tbin[1]);
	void *status;
	for (int i=0; i<nbtr; i++){
		pthread_join (t[i],&status);
	}
}

int main (int argc, char *argv[])
{
	test_preadpack(argc,argv);
}

